#ifndef CYCLES_H
#define CYCLES_H

typedef unsigned long long cycles_t;

#define CYCLES_FMT "llu"

static inline cycles_t get_cycles(void)
{
        unsigned long long ret;
        __asm__ __volatile__("rdtsc" : "=A" (ret));
        return ret;
}

static inline double cycles2usec(cycles_t x)
{
	return x / 2700.0;
}

static inline cycles_t usec2cycles(double x)
{
	return x * 2700;
}

#endif
