#ifndef __I386_SPINLOCK_H
#define __I386_SPINLOCK_H

/* from Linux 2.6.24 */

typedef struct {
	unsigned int slock;
} raw_spinlock_t;

#define __RAW_SPIN_LOCK_UNLOCKED	{ 1 }

typedef raw_spinlock_t spinlock_t;
#define DEFINE_SPINLOCK(x) spinlock_t x = {1};
#define spin_lock(x)    __raw_spin_lock(x)
#define spin_unlock(x)  __raw_spin_unlock(x)

#define LOCK_PREFIX "lock; "

static inline void __raw_spin_lock(raw_spinlock_t *lock)
{
	asm volatile("\n1:\t"
		     LOCK_PREFIX " ; decb %0\n\t"
		     "jns 3f\n"
		     "2:\t"
		     "rep;nop\n\t"
		     "cmpb $0,%0\n\t"
		     "jle 2b\n\t"
		     "jmp 1b\n"
		     "3:\n\t"
		     : "+m" (lock->slock) : : "memory");
}

static inline void __raw_spin_unlock(raw_spinlock_t *lock)
{
	asm volatile("movb $1,%0" : "+m" (lock->slock) :: "memory");
}

#endif 
