#ifndef TICKETLOCK_H
#define TICKETLOCK_H

/* from 2.6.28 */

typedef struct ticket_lock {
	unsigned int slock;
} ticket_lock_t;

#define DEFINE_TICKETLOCK(x) ticket_lock_t x = { 0 }

#define LOCK_PREFIX "lock; "
#define UNLOCK_LOCK_PREFIX ""

static __inline__ void ticket_lock(ticket_lock_t *lock)
{
	short inc = 0x0100;

	asm volatile (
		LOCK_PREFIX "xaddw %w0, %1\n"
		"1:\t"
		"cmpb %h0, %b0\n\t"
		"je 2f\n\t"
		"rep ; nop\n\t"
		"movb %1, %b0\n\t"
		/* don't need lfence here, because loads are in-order */
		"jmp 1b\n"
		"2:"
		: "+Q" (inc), "+m" (lock->slock)
		:
		: "memory", "cc");
}

static __inline__ void ticket_unlock(ticket_lock_t *lock)
{
	asm volatile(UNLOCK_LOCK_PREFIX "incb %0"
		     : "+m" (lock->slock)
		     :
		     : "memory", "cc");
}

#endif 
