#ifndef CYCLES_H
#define CYCLES_H

#define NPT_BIT 63

typedef unsigned long cycles_t;

#define CYCLES_FMT "lu"

static inline cycles_t get_cycles(void) {
	unsigned long cycles = 0;
	__asm__ __volatile__("rd %%asr24, %0" : "=r" (cycles));
	return cycles & ~(1UL << NPT_BIT);
}

static inline double cycles2usec(cycles_t x)
{
	return x / (double) 1200;
}

static inline cycles_t usec2cycles(double x)
{
	return x * 1200;
}
#endif
