#ifndef BARW_PROTO1_H
#define BARW_PROTO1_H

typedef struct {
	volatile u32 win, rin;
	volatile u32 wout, rout;	
} ba_proto1_rwlock_t;

#define DEFINE_BA_PROTO1_RWLOCK(x) ba_proto1_rwlock_t x =	\
	{ 0, 0, 0, 0 }

static inline void ba_proto1_read_lock(ba_proto1_rwlock_t *l)
{
	u32 blocked = xadd32(4, &l->rin) & 0x3;
	while (blocked && ((l->rin & 0x3) == blocked))
		cpu_relax();
}

static inline void ba_proto1_read_unlock(ba_proto1_rwlock_t *l)
{
	xadd32(4, &l->rout);
}

static inline void ba_proto1_write_lock(ba_proto1_rwlock_t *l)
{
	u32 ticket;
	ticket = xadd32(1, &l->win) - 1;
	while (ticket != l->wout)  {
		cpu_relax();
	}
	ticket = xadd32(0x2 | (ticket & 0x1), &l->rin) & (~(u32)3);
	while (ticket != l->rout)
		cpu_relax();
}

static inline void ba_proto1_write_unlock(ba_proto1_rwlock_t *l)
{
	u32 ticket = l->wout;
	xadd32((u32) -(0x2 | (ticket & 0x1)), &l->rin);
	l->wout++;
}

#endif
