#ifndef _MCSRW_COMMON_H_
#define _MCSRW_COMMON_H_

typedef enum {
	NONE   = 0,
	READER = 1,
	WRITER = 2,
} mcs_rw_class_t ;

struct __mcs_rw_state {
	volatile u16 blocked; /* volatile needed for spinning in C */
	u16 next_cls;
};

typedef union {
	struct __mcs_rw_state state;
	u32 raw;
} __mcs_atomic_u;

typedef struct __mcsrwnode
{
	mcs_rw_class_t cls;
	volatile struct __mcsrwnode *next; /* volatile needed for spinning in C */
	__mcs_atomic_u u;
} mcs_rwnode_t;

typedef struct
{
	u32 count;
	mcs_rwnode_t*	tail;
	mcs_rwnode_t*   nextw;
} mcs_rwlock_t;

#define DEFINE_MCS_RWLOCK(name) mcs_rwlock_t name = { 0, NULL, NULL }
#define DEFINE_MCS_RWNODE(name) mcs_rwnode_t name

static inline u32 mcs_reader_count(mcs_rwlock_t* l)
{
	return l->count;
}

#endif
