#ifndef TICKET_PROTO1_H
#define TICKET_PROTO1_H

#include "mem.h"
#include "atomic.h"

typedef struct  {
	atomic_t tail;
	atomic_t head;
} ticket_proto1_lock_t;

#define DEFINE_PROTO1LOCK(x) ticket_proto1_lock_t x =\
	{ ATOMIC_INIT(0), ATOMIC_INIT(0) }

static inline void ticket_proto1_lock(ticket_proto1_lock_t *l)
{
	int ticket = atomic_add_return_old(1, &l->tail);
	while (ticket != atomic_read(&l->head)) {
		cpu_relax();
	}
}

static inline void ticket_proto1_unlock(ticket_proto1_lock_t *l)
{
	atomic_add(1, &l->head);
}

#endif
