#ifndef TICKET_PROTO2_H
#define TICKET_PROTO2_H

#include "mem.h"
#include "atomic.h"

typedef struct  {
	atomic_t     tail;
	volatile int head;
} ticket_proto2_lock_t;

#define DEFINE_PROTO2LOCK(x) ticket_proto2_lock_t x =\
	{ ATOMIC_INIT(0), 0 }

static inline void ticket_proto2_lock(ticket_proto2_lock_t *l)
{
	int ticket;
	ticket = atomic_add_return_old(1, &l->tail);
	while (ticket != l->head)
		cpu_relax();
}

static inline void ticket_proto2_unlock(ticket_proto2_lock_t *l)
{
	mb();
	l->head++;
	mb();
}

#endif
