#!/bin/bash

DELAYS="1.0 2.0 3.0 4.0 5.0 6.0 7.0 10.0"

WRATIOS="0 0.01 0.05 0.1 0.2 0.35 0.5 1"

TESTS="rwpf rwmcssp rwpfqp rwmcsp rwmtx-mcsp rwmtx-lin  rwmtx-ticket rwnone rwlin"

for T in $TESTS
do
    if [ ! -x ./$T ]
    then
	MISSING="$MISSING $T"
    fi
done
if [ ! -z "$MISSING" ]
then
    echo "(EE) The following tests are not available: $MISSING."
    exit 1
fi

for D in $DELAYS
do
    for W in $WRATIOS
    do
	for T in $TESTS
	do
	    F="data/$T-D=$D-W=$W.csv"
	    if [ -e $F ]
	    then
		echo "Skipping $T $W $D; data file exists."
	    else
		date
		echo "Running $T $W $D"
		schedtool -F -p 1 -e ./$T -d $D -w $W > $F
	    fi
	done
    done
done
