#include <stdio.h>

#include <sys/types.h>

#include "kernel_compat.h"
#include "locks/mcsrw_common.h"
#include "locks/mcsrw.h"

#define offset_of(x, y) ((unsigned long) &((x*)0)->y)

#define PSIZE(x)     printf("\t%-10s: %3lu\n", #x, (unsigned long) sizeof(x));
#define OFFSET(x, y) printf("\t%3lu %-10s\n", offset_of(x,y), "->" #y)

typedef enum {
	A,
	B,
	C
} enum_t;

int foo(void)
{
	DEFINE_MCS_RWLOCK(l);
	DEFINE_MCS_RWNODE(x);
	DEFINE_MCS_RWNODE(x2);

	 __mcs_atomic_u old, new;

	mcs_write_lock(&l, &x);
	printf("w: in\n");
	mcs_write_unlock(&l, &x);

	mcs_read_lock(&l, &x);
	printf("r1: in\n");
	mcs_read_lock(&l, &x2);
	printf("r2: in\n");
	mcs_read_unlock(&l, &x);
	printf("r1: out\n");
	mcs_read_unlock(&l, &x2);
	printf("r2: out\n");

	old.state = (struct __mcs_rw_state) {1, NONE};
	new.state = (struct __mcs_rw_state) {1, READER};
	printf("old: 0x%x\n", old.raw);
	printf("new: 0x%x\n", new.raw);
	return 0;
}

int main(int argc, char** argv)
{
	printf("Sizes:\n");
	PSIZE(char);
	PSIZE(short);
	PSIZE(int);
	PSIZE(long);
	PSIZE(long long);
	PSIZE(void*);
	PSIZE(enum_t);
	printf("Offsets mcs_rwlock_t:\n");
	OFFSET(mcs_rwlock_t, count);
	OFFSET(mcs_rwlock_t, tail);
	OFFSET(mcs_rwlock_t, nextw);
	printf("Offsets mcs_rwnode_t:\n");
	OFFSET(mcs_rwnode_t, cls);
	OFFSET(mcs_rwnode_t, next);
	OFFSET(mcs_rwnode_t, u);
	OFFSET(mcs_rwnode_t, u.state.blocked);
	OFFSET(mcs_rwnode_t, u.state.next_cls);
	foo();
	return 0;
}
