#include <stdio.h>
#include <string.h>

#define KB 1024
#define MB 1024 * KB

#define streq(x, y) (0 == strcmp(x, y))

static const char* mega[] = {"M", "m", "Mb", "mb", NULL};
static const char* kilo[] = {"K", "k", "Kb", "kb", NULL};

static int str_one_of(const char* str, const char* set[])
{
	for (; *set; set++)
		if (streq(str, *set))
			return 1;
	return 0;
}

int multiplier(const char* unit_str)
{
	if (streq(unit_str, ""))
	    return 1;
	else if (str_one_of(unit_str, mega))
		return MB;
	else if (str_one_of(unit_str, kilo))
		return KB;
	else
		return 0;
}

int str2int(char* str, int *var)
{
	char unit[3];
	int tmp;
	unit[0] = 0;
	switch (sscanf(str, "%d%3s", var, unit)) {
	default:
		return 0;
	case 1:
		return 1;
	case 2:
		unit[2] = 0;
		tmp = multiplier(unit);
		*var *= tmp;
		return tmp;
	};
}

int str2float(char* str, float *var)
{
	char unit[3];
	int tmp;
	unit[0] = 0;
	switch (sscanf(str, "%f%3s", var, unit)) {
	default:
		return 0;
	case 1:
		return 1;
	case 2:
		unit[2] = 0;
		tmp = multiplier(unit);
		*var *= tmp;
		return tmp;
	};
}
